//-----------------------------------------------------
//  Rȓȉ~֐Ɠ꒵т̕RvZ
// http://fuchino.ddo.jp/yatsugatake/ellipticx.pdf
// http://www.wannyan.net/scidog/ellipse/ellipse.pdf
//-----------------------------------------------------
unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, VclTee.TeeGDIPlus,
  VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs, VCLTee.Chart;

type
  TForm1 = class(TForm)
    LabeledEdit10: TLabeledEdit;
    LabeledEdit11: TLabeledEdit;
    Memo1: TMemo;
    nawaBtn: TButton;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TPointSeries;
    massEdit: TLabeledEdit;
    rotational_speed_Edit: TLabeledEdit;
    LabeledEdit1: TLabeledEdit;
    CheckBox1: TCheckBox;
    LabeledEdit2: TLabeledEdit;
    Series3: TLineSeries;
    Image1: TImage;
    procedure nawaBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private 錾 }
    function jacobi_sn(u, k: double): double;
    procedure tension(a2, k, b, c: double);
    function invertK(L, a2: double): double;
    function Jacobi_am(u, k: double): double;
    procedure DrawingSet;
    procedure ImageClear;
    procedure DrawingLine(i: integer; x, y: double);
    procedure AreaDrawing(a2, k, b, c, Lp : double);
    procedure elliptic_integral(I: integer; k :double; var F, E : double);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Math;

var
  DBL_EPSILON : double;

// 튮Sȉ~ϕ
// 1 @2 
procedure TForm1.elliptic_integral(I: integer; k :double; var F, E : double);
var
  ch : integer;
  n  : integer;
  kn : array of double;
  sigumaK : double;
  knd : array of double;
  kkn : array of double;
  Ekn : array of double;
begin
  E := 0;
  if K >= 1 then begin
    F := Infinity;                     // 
    E := 1;
    exit
  end;
  n := 0;
  setlength(kn, 1);
  kn[0] := k;
  sigumaK := 0;
  while kn[n] <> sigumaK do begin      // kn
    sigumaK := kn[n];
    inc(n);
    setlength(kn, n + 1);
    kn[n] := (1 - sqrt(1 - sigumaK * sigumaK)) / (1 + sqrt(1 - sigumaK * sigumaK));
  end;
  setlength(kn, n);                             // Ă̂ňȂ
  dec(n);                                       // Ȃ
  sigumaK := 1 + kn[1];
  for ch := 2 to n do begin
    sigumaK := sigumaK * (1 + kn[ch]);
  end;
  F := sigumaK * pi / 2;                        // 튮Sȉ~ϕ
  if I = 1 then exit;
  setlength(knd, n);
  for ch := 0 to n - 1 do
    knd[ch] := sqrt(1- kn[ch] * kn[ch]);        // knL
  setlength(kkn, n + 1);
  kkn[n] := pi / 2;
  for ch := n - 1 downto 0 do
    kkn[ch] := (1+ kn[ch + 1]) * kkn[ch + 1];   // kkn(kn)
  setlength(Ekn, n + 1);
  Ekn[n] := pi / 2;
  for ch := n - 1 downto 0 do
    Ekn[ch] := (1 + knd[ch]) * Ekn[ch + 1] - knd[ch] * kkn[ch];   // E(kn)
  E := Ekn[0];                                  // 튮Sȉ~ϕ
end;

// U֐ am(u, k)
function TForm1.Jacobi_am(u, k: double): double;
const
  KN = 30;
var
  a: array of double;
  g: array of double;
  c: array of double;
  two_n   : double;
  phi     : double;
  half    : double;
  i, j    : integer;
begin
  half := 1 / 2;
  if k = 0 then begin
    result := u;
    exit;
  end;
  if k = 1 then begin
    result := 2 * arctan(exp(u)) - pi / 2;
    exit;
  end;
  setlength(a, KN + 1);
  setlength(g, KN + 1);
  setlength(c, KN + 1);
  a[0] := 1;
  g[0] := sqrt(1 - k * k);
  c[0] := k;
  two_n := 1;
  for i := 0 to KN do begin
    if abs(a[i] - g[i]) < a[i] * DBL_EPSILON then break;
    two_n := two_n + two_n;
    a[i + 1] := half * (a[i] + g[i]);
    g[i + 1] := sqrt(a[i] * g[i]);
    c[i + 1] := half * (a[i] - g[i]);
  end;
  phi := two_n * a[i] * u;
  for j := i downto 1 do
    phi := half * (phi + arcsin(c[j] * sin(phi) / a[j]));
  result := phi;
end;

// Rȓȉ~֐
function TForm1.jacobi_sn(u, k: double):double;
begin
  result := sin(Jacobi_am(u, k));
end;

// cǩvZ
// L=4a/k'^2*E/K-2aaLmȂ̂k̒l߂܂B
function TForm1.invertK(L, a2: double): double;
var
  c, fc     : double;
  k, E, fk  : double;
  dk        : double;
  N         : integer;
  kb        : double;
begin
  a2 := abs(a2);
  c := (L + a2) / a2 / 2;                     // L=4a/k'^2*E/K-2a 画pŒlvZ
  dk := 1 / 2;                                // k
  k := dk;                                     // Sl
  N := 0;
  repeat
    inc(N);
    if k >= 1 then k := 1 - DBL_EPSILON;      // k1ɐ1͂ɏ܂B
    elliptic_integral(2, k, fk, E);           // 튮Sϕ
    fc := E / fk / (1 - k * k);               // rlvZ
    if fc > c then begin                      // 傫
      k := k - dk;                            // kZ
      dk := dk / 2;                           // k@21
    end;
    kb := k;
    k := k + dk;                              // k+k
  until (kb = k) or (N > 200);                //   k̒lωȂȂ
  memo1.Lines.Add('cvZ[v N = ' + intTostr(N));
  result := k;
end;

// R̒́A vZ
procedure TForm1.tension(a2, k, b, c: double);
const
  KN = 1000;
var
  ch, i       : integer;
  p, w        : double;
  R, T        : double;
  Tv, T0, g   : double;
  u, g2       : double;
  x, y, yb    : double;
  dx, ty      : double;
  snuk        : double;
  lp, fp      : double;
  Sl, d2      : double;
  Ke, E       : double;
begin
  val(massEdit.Text, p, ch);
  if ch <> 0 then begin
    application.MessageBox('R̎ʂɊԈႢ܂B','', 0);
    exit;
  end;
  if p < 0 then begin
    application.MessageBox('R̎ʂɃ}CiX͂܂B','', 0);
    exit;
  end;
  val(rotational_speed_Edit.Text, R, ch);
  if ch <> 0 then begin
    application.MessageBox(']ɊԈႢ܂B','', 0);
    exit;
  end;
  w := R / 60 * pi * 2;                                     // px 
  g := p * w * w;                                           // =*^2
  elliptic_integral(1, k, ke, E);                           // 튮Sϕ
  T0 := g * a2 * a2 / 4 / (1 - k * k) / Ke / Ke;
  memo1.Lines.Add('R̐(N)    To= ' + floatTostrF(T0, ffFixed, 10, 5));
  T := T0 * sqrt(b * b / c / c + 1);
  memo1.Lines.Add('R̒(N)@        T'' = ' + floatTostrF(T, ffFixed, 10, 5));
  memo1.Lines.Add('');
  memo1.Lines.Add('lؕϕvZ');
  g2 := g / 2;                                    // όS͌vZ̈ד񕪂̈ɂ܂
  dx := a2 / KN / 2;                              // x
  d2 := dx * dx;
  Tv := 0;
  Sl := 0;
  yb := 0;
  for i := 1 to KN do begin                       // ϕ
    x := i * dx;                                  // xʒu
    u := x  / c;                                  // F(,k)=u
    snuk := jacobi_sn(u, k);                      // jacobi_sn  Rȓȉ~֐
    y := snuk * b;                                // xʒuy̒l
    ty := (y - yb);                               // y
    lp := sqrt(d2 + ty * ty);                     // l
    Sl := Sl + lp;                                // Lv
    fp := lp * (y + yb) * g2;                     // yyb̕όS
    Tv := Tv + fp;                                // Fv
    yb := y;
  end;                                            // R̒
  Sl := Sl * 2;
  if checkbox1.Checked then
    memo1.Lines.Add('@Ŕ@@@@ @@@ L'' = ' + floatTostrF(Sl, ffFixed, 10, 5));
  memo1.Lines.Add('@R̐(N)@  Tv= ' + floatTostrF(Tv, ffFixed, 10, 5));
  if b = 0 then T := 0
           else T := Tv * sqrt(c * c / b / b + 1);
//  T := Tv / b * sqrt(b * b + c * c);
  memo1.Lines.Add('@R̒(N)@        T'' = ' + floatTostrF(T, ffFixed, 10, 5));
end;

var
  xbase, ybase : integer;     // Wl
  xsb, ysb     : double;      // Otl
  xs, ys       : double;      // WϊWl

// ̕`
// 0 : Move    1 : Lineto
procedure TForm1.DrawingLine(i: integer; x, y: double);
var
  xpos, ypos: integer;
begin
  //     (Xl - Xl) * XWϊW + XW
  xpos := round((x - xsb) * xs) + xbase;
  //     (Yl - Yl) * YWϊW + YW
  ypos := round((y - ysb) * ys) + ybase;
  if i = 0 then Image1.Canvas.MoveTo(xpos, ypos)
           else Image1.Canvas.LineTo(xpos, ypos);
end;

// wi}`ݒ
procedure TForm1.DrawingSet;
begin
  with series2 do begin
    xbase := calcXpos(1);                          // [XW      XW
    ybase := calcYpos(1);                          // [YW      YW
    xsb := XValues.Items[2] - XValues.Items[1];    // X͈
    xs := (calcXpos(2) - calcXpos(1)) / xsb;       // XWւ̕ϊW
    xsb := XValues.Items[1];                       // [̒l         Xl
    ysb := YValues.Items[0] - YValues.Items[1];    // y͈
    ys := (calcYpos(0) - calcYpos(1)) / ysb;       // YWւ̕ϊW
    ysb := YValues.Items[1];                       // [̒l         Yl
  end;
end;

// vZw͈͓hԂ
procedure TForm1.AreaDrawing(a2, k, b, c, Lp : double);
var
  i : integer;
  dx, x, y, u, snuk: double;
  a : double;
begin
  DrawingSet;
  // Ot}
  a := a2 / 2;
  dx := 3 / xs;                                     // sb`ݒ
  Image1.Canvas.Pen.Width := 3;                     // ̕ hԂɂȂ
  Image1.Canvas.Pen.Color := clYellow;              // hԂF
  i := 0;
  x := 0;
  repeat
    u := x / c;                                     // F(,k)=u
    snuk := jacobi_sn(u, k);                        // jacobi_sn  Rȓȉ~֐
    y := snuk * b;                                  // xʒuy̒l
    DrawingLine(0, x - a, y);                       // moveTo(x,y)
    DrawingLine(1, x - a, 0);                       // lineTo(x,y)
    inc(i);
    x := i * dx;                                    // xʒu
  until x >= Lp;                                    // wʒu
  Chart1.BackImage.Bitmap := Image1.Picture.Bitmap; // OtwiImage1Rs[
end;

// ꒵т̓o݌vZ
procedure TForm1.nawaBtnClick(Sender: TObject);
var
  KN        : integer;
  k         : double;
  ch        : integer;
  a, a2     : double;
  fkd, b, u : double;
  c, L      : double;
  i         : integer;
  x, y, dx  : double;
  snuk      : double;
  ty, by    : double;
  lx, rx    : double;
  def, ddf  : double;
  Ek        : double;
  Lk        : double;
  siguma    : double;
  Lp, LLP   : double;
  dx2       : double;
  S         : double;
  Lb        : double;
begin
  KN := 1000;
  k := 0;                     // S
  L := 0;                     // R
  val(Labelededit10.Text, a2, ch);
  if ch <> 0 then begin
    application.MessageBox('꒵ѕRxԂɊԈႢ܂B','',0);
    exit;
  end;
  if a2 < 0 then begin
    application.MessageBox('xԂ̒lɃ}CiX͂܂B','',0);
    exit;
  end;
  val(Labelededit2.Text, Lp, ch);
  if ch <> 0 then begin
    application.MessageBox('̈ʒuɊԈႢ܂B','',0);
    exit;
  end;
  if Lp < 0 then begin
    application.MessageBox('̈ʒuɃ}CiX͂܂B','',0);
    exit;
  end;
  if checkbox1.Checked then begin
    val(LabeledEdit1.Text, k, ch);
    if ch <> 0 then begin
      application.MessageBox('꒵ѕRSjɊԈႢ܂B','',0);
      exit;
    end;
    if k >= 1 then begin
      application.MessageBox('k(S)̒lPȉɂĉB','',0);
      exit;
    end;
    if k < 0 then begin
      application.MessageBox('k(S)̒lɃ}CiX͂܂B','',0);
      exit;
    end;
  end
  else begin
    val(LabeledEdit11.Text, L, ch);
    if ch <> 0 then begin
      application.MessageBox('꒵ѕR̒ɊԈႢ܂B','',0);
      exit;
    end;
    if L <= abs(a2) then begin
      application.MessageBox('R͎̒xԂ蒷ĂB','',0);
      exit;
    end;
  end;
  memo1.Clear;
  if not checkbox1.Checked then begin
    memo1.Lines.Add('R̒(L=' + floatTostr(L) + ')wvZ');
    k := invertK(L, a2);                                    // cǩvZ
    memo1.Lines.Add('c@@@@ @@@  k = ' + floatTostrF(k, ffFixed, 10, 5));
  end
  else
    memo1.Lines.Add('S(k=' + floatTostr(k) + ')wvZ');
  elliptic_integral(2, k, fkd, Ek);                           // 튮Sϕ
  if abs(k) = 0 then begin
    application.MessageBox('S[łB','',0);
    exit;
  end;
  // evZ
  a := a2 / 2;
  c := a / fkd;                                             // ϕlɑ΂ȐW
  b := 2 * k / (1 - k * k) * c;                             // ől ̈ʒu
  memo1.Lines.Add('ȐW@@@@@@  c = ' + floatTostrF(c, ffFixed, 10, 5));
  memo1.Lines.Add('R̒S@ @@@ b = ' + floatTostrF(b, ffFixed, 10, 5));
  // R̒vZ ԈʒǔvZ͏o܂
  if checkbox1.Checked then begin
    Lk := 4 * c * Ek / (1 - k * k) - a2;                    // ʂ̒vZ
    memo1.Lines.Add('R̒@@@@@@@@L = ' + floatTostrF(Lk, ffFixed, 10, 5));
  end;
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  ImageClear;
  application.ProcessMessages;
  // OtXP[ݒ
  Lb := 0;                        // Lb ꍂŏl
  if (Lp > a2) then
    if (Lp < a2 * 1.5) then begin
      x := Lp;                    // xʒu
      u := x / c;                 // F(,k)=u
      snuk := jacobi_sn(u, k);    // jacobi_sn  Rȓȉ~֐
      Lb := snuk * b;             // ̎xԂvZwʒu傫ꍇ
    end
    else Lb := -b;                // ̎xԂvZwʒu1.5{ȏ゠ꍇ
  // pi/2͈̔͂̂ݓ{\ݒ
  if (a2 > abs(b)) or (Lp > abs(b)) then begin
    ddf := a2 / 10;             // ]
    def := (a2 - b) / 2;        // ㉺ǉ]
    ty := b + def + ddf;
    by := Lb - def - ddf;
    rx :=  a + ddf;
    if Lp > a2 then             // E[vZwʒuxʒuE
      rx := Lp - a + ddf;       // E[E[vZʒuɐݒ
    lx := -a - ddf;
  end
  else begin
    ddf := b / 10;              // ]
    def := (b - a2) / 2;        // Eǉ]
    ty := b + ddf;
    by := 0 - ddf;
    rx :=  a + def + ddf;
    lx := -a - def - ddf;
    if a2 < Lp then begin       // E[vZwʒuxʒuE
      rx :=  Lp + ddf - a;      // E[E[vZʒuɐݒ
      lx := -a - ddf;           // []ύX
    end;
  end;
  // Ot̃XP[ݒlZbg
  // Series2̓Otsݒ
  Series2.AddXY(lx, ty);
  Series2.AddXY(lx, by);
  Series2.AddXY(rx, by);
  application.ProcessMessages;                      // Ot\҂
  // Ot}
  dx := a2 / KN;                                    // X
  // 0`KN@vZ}
  for i := 0 to KN do begin
    x := i * dx;                                    // xʒu
    u := x / c;                                     // F(,k)=u
    snuk := jacobi_sn(u, k);                        // jacobi_sn  Rȓȉ~֐
    y := snuk * b;                                  // xʒuy̒l
    Series1.AddXY(x - a, y);                        // Otɒǉ
  end;
  application.ProcessMessages;                      // Ot\҂
  // [_͌vZ
  tension(a2, k, b, c);
  // ϕ
  KN := round(Lp / a2 * 100);
  if KN = 0 then KN := 1;
  KN := KN * 10;
  dx := Lp / KN;                                    // X
  dx2 := dx / 2;                                    // X / 2
  siguma := 0;                                      // pvlNA
  S := 0;                                           // ʐϗpvlNA
  // ϕ͈̓X^[gʒu
  Series3.AddXY(0 - a, 0);                          // Otɒǉ
  // w͈͒ʐϕϕvZ
  for i := 0 to KN - 1 do begin
    x := i * dx + dx2;                              // +dx2  xʒuԈʒuŌvZ̈
    u := x / c;                                     // F(,k)=u
    // jacobi_sn  Rȓȉ~֐   ̌vZ
    snuk := jacobi_sn(u, k);                        // jacobi_sn(u, k)
    y := snuk * b;
    Series3.AddXY(x - a, y);                        // Otɒǉ
    S := S + abs(y);                                // ʐϗp y
    y := (1 - k * k * snuk * snuk);                 // dn^2(u) = 1-K^2*sn^2(u)
    siguma := siguma + y;                           // vZpϕ vl
  end;
  // ϕ͈͕\ׂ̈̒ǉłvZɂ͊֌W܂
  u := Lp / c;                                      // F(,k)=u
  snuk := jacobi_sn(u, k);                          // jacobi_sn(u, k)
  y := snuk * b;
  Series3.AddXY(Lp - a, y);                         // Otɒǉ
  application.ProcessMessages;                      // Ot\҂
  //--------------------------------------------------------
  LLP := 2 / (1- k * k) * siguma * dx - Lp;         // 
  memo1.Lines.Add('@wʒu܂ł̒  Ls= ' + floatTostrF(LLP, ffFixed, 10, 5));
  S := S * dx;                                      // ʐόvZ y * dx
  memo1.Lines.Add('@wʒu܂ł̖ʐ   S= ' + floatTostrF(S, ffFixed, 10, 5));
  AreaDrawing(a2, k, b, c, Lp);
end;

// R̒(L)wƗS(K)vZ̎w؂ւ
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then begin
    labeledEdit1.Enabled := True;
    labeledEdit11.Enabled := False;
  end
  else begin
    labeledEdit1.Enabled := False;
    labeledEdit11.Enabled := True;
  end;
end;

// ^uI[_[ɂCheckBoxIL[͊荞݂Ń`FbNZbg
procedure TForm1.CheckBox1KeyPress(Sender: TObject; var Key: Char);
begin
  if CheckBox1.Checked then CheckBox1.Checked := False
                       else CheckBox1.Checked := True;
end;

// Otwi
procedure TForm1.ImageClear;
begin
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clWhite;
  Image1.Canvas.FillRect(rect(0, 0, Image1.Width, Image1.Height));
  Image1.Canvas.Brush.Style := bsClear;
  Chart1.BackImage.Bitmap := Image1.Picture.Bitmap;   // OtwiImage1Rs[
end;

// Nݒ
// Otwiprbg}bvݒ
procedure TForm1.FormCreate(Sender: TObject);
var
  bm : Tbitmap;
  x, y, z : double;
  i       : integer;
begin
  i := 0;
  x := 1;
  y := 1;
  repeat
    y := y / 2;
    z := x + y;
    inc(i);
  until (z = x) or (i > 100);
  DBL_EPSILON := y * 2;
  labeledEdit1.Enabled := False;        // Edit1͋֎~
  bm := Tbitmap.Create;                 // bitmap
  bm.Width := Chart1.Width;
  bm.Height := Chart1.Height;
  Image1.Width := Chart1.Width;
  Image1.Height := Chart1.Height;
  Image1.Picture.Bitmap := bm;          // Image1Ƀrbg}bvt
  Image1.Visible := False;              // Image1\
  bm.Free;                              // bitmapJ
  ImageClear;                           // Image1
end;

end.
